Rygel.SimpleContainer – librygel-server Reference Manual

# SimpleContainer

## Object Hierarchy:

## Description:

public class SimpleContainer : MediaContainer, SearchableContainer

A simple implementation of RygelMediaContainer that keeps all RygelMediaObjects in memory. You should add children via rygel_simple_container_add_child_item().

Namespace: Rygel
Package: librygel-server

## Content:

### Properties:

- public `ArrayList`<`string`> search_classes { set; get; }

### Creation methods:

- public SimpleContainer (`string` id, MediaContainer? parent, `string` title)
  Creates a child RygelSimpleContainer.
- public SimpleContainer.root (`string` title)
  Creates a RygelSimpleContainer as a root container.

### Methods:

- public override void constructed ()
- public void add_child_item (MediaItem child)
  Adds an item to the container.
- protected MediaObjects get_all_children ()
  Get all children, including the empty children.
- public void add_child_container (MediaContainer child)
  Adds a child container to this container.
- public void remove_child (MediaObject child)
  Removes the item from the container.
- public void clear ()
  Removes all child items and child containers from the container.
- protected `bool` is_child_id_unique (`string` child_id)
  Check that the ID is unique within this container.
- public override async MediaObjects? get_children (`uint` offset, `uint` max_count, `string` sort_criteria, `Cancellable`? cancellable) throws `Error`
- public override async MediaObject? find_object (`string` id, `Cancellable`? cancellable) throws `Error`
- public async MediaObjects? search (SearchExpression? expression, `uint` offset, `uint` max_count, out `uint` total_matches, `string` sort_criteria, `Cancellable`? cancellable) throws `Error`

### Fields:

- public MediaObjects children

### Inherited Members:

All known members inherited from class Rygel.MediaContainer

- ANY
- UPNP_CLASS
- STORAGE_FOLDER
- MUSIC_ALBUM
- MUSIC_ARTIST
- MUSIC_GENRE
- PLAYLIST

- ALBUM_SORT_CRITERIA
- child_count
- sort_criteria
- constructed
- get_children
- find_object

- updated
- container_updated
- sub_tree_updates_finished
- update_id
- storage_used
- total_deleted_child_count

All known members inherited from class Rygel.MediaObject

- id
- ref_id
- upnp_class
- modified
- object_update_id

- parent
- parent_ref
- title
- constructed
- get_writable

- get_writables
- compare_string_props
- compare_int_props
- uris
- parent_ptr

All known members inherited from class GLib.Object

- @new
- newv
- new_valist
- get_type
- get_class
- @ref
- unref
- ref_sink
- weak_ref
- weak_unref
- add_weak_pointer
- remove_weak_pointer

- @get
- @set
- get_property
- set_property
- get_data
- set_data
- set_data_full
- steal_data
- get_qdata
- set_qdata
- set_qdata_full
- steal_qdata

- freeze_notify
- thaw_notify
- dispose
- constructed
- notify_property
- connect
- disconnect
- add_toggle_ref
- remove_toggle_ref
- bind_property
- notify
- ref_count

All known members inherited from interface Rygel.SearchableContainer

- search_classes
- search

- simple_search

- find_object